
//@vs
//////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
	vs_out_p = matWVP * POS0;
	vs_out_0 = CLR0.xyzw;
	vs_out_1 = float4 (TUV0.xy, 0, 0);

#ifdef sd_PCTTMaskAlpha
	vs_out_1.zw = TUV1.xy;
#endif

#ifdef sd_PCTTMaskMulti
	vs_out_1.zw = TUV1.xy;
#endif
}

#endif


//@ps
//////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

#define DiffColor		ps_in_0.xyzw
#define TexUV				ps_in_1.xy

void main () 
{  
#ifdef sd_Default
	ps_out_c = texture2D (c_samp0, TexUV) * DiffColor * UserColor.xyzw;	
#endif

#ifdef sd_Simple
	ps_out_c = texture2D (c_samp0, TexUV) * DiffColor;	
#endif

#ifdef sd_UI
	float4 texD = texture2D (c_samp0, TexUV);	
	float3 gray = (texD.x*0.3 + texD.y*0.4 + texD.z*0.3) * float3 (1,1,1);
	float3 rcolor = lerp (texD.xyz*DiffColor.xyz, gray, GrayRatio);
	ps_out_c = float4 (rcolor.xyz, texD.w*DiffColor.w);
#endif

#ifdef sd_RGB
	float4 texD = texture2D (c_samp0, TexUV) * UserColor.xyzw;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);
	ps_out_c = float4 (DiffColor.xyz, sum*DiffColor.w);
#endif

#ifdef sd_RGBx
	float4 texD = texture2D (c_samp0, TexUV) * DiffColor;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);
	ps_out_c = float4 (UserColor.xyz, sum*UserColor.w);
#endif

#ifdef sd_RGB22
	float4 texD = texture2D (c_samp0, TexUV) * UserColor.xyzw;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);
	ps_out_c = float4 (DiffColor.xyz*sum, 1.0);
#endif

#ifdef sd_ShwRGB
	float4 texD = texture2D (c_samp0, TexUV) * DiffColor.xyzw;
	float sum = 1.0 - saturate (texD.x + texD.y + texD.z);
	ps_out_c = float4 (0,0,0, sum*DiffColor.w);
#endif

#ifdef sd_Text
	float4 texD = texture2D (c_samp0, TexUV) * DiffColor.xyzw;
	float sum = saturate (texD.x + texD.y + texD.z + texD.w);

	float F = saturate (0.0 + (sum - 0.1) * 1.3);
	sum = saturate (sum * 3.0);

	ps_out_c = float4 (UserColor.xyz*F, sum*UserColor.w);
	//ps_out_c = float4 (1,1,1,1);
#endif

#ifdef sd_PCTTMaskAlpha
	float4 diff = texture2D (c_samp0, TexUV     );
	float4 color = diff * DiffColor * UserColor.xyzw;	
	float4 mask  = texture2D (c_samp1, ps_in_1.zw);	
	ps_out_c = float4 (color.xyz, mask.x * diff.x);
#endif

#ifdef sd_PCTTMaskMulti
	float4 color = texture2D (c_samp0, TexUV     ) * DiffColor * UserColor.xyzw;	
	float4 mask  = texture2D (c_samp1, ps_in_1.zw);	
	ps_out_c = float4 (color.xyz*mask.xyz, mask.w*color.w);
#endif

}

#endif










