
//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

void main () 
{	
	float4 lP = POS0;
#ifdef sd_Animate
	lP = lerp ( POS0, POS1, Weight0 );
#endif

	float3 wP = (matW * lP).xyz;
	float3 wN = normalize(matW * float4(NOR0.xyz, 0.0)).xyz;
	float3 wE = normalize (EyePos - wP.xyz).xyz;
	
	float3 ambc = float3 (Ambient, Ambient, Ambient);// calc_hemisphere (wN, float3(0,0,1)/*sky*/, GrwColor, SkyColor, Ambient);
	float sun_diff = calc_diffuse (SunDir, wN, LambertPow);
	float sun_spec = calc_specular (SunDir, wN, wE, SpecIntensity*SpecRatio, SpecPow);
	float rim = 0.0;//calc_rimlight (SunDir, wN, wE, RimIntensity, RimBand);

#ifdef sd_Detail
	sun_spec = calc_specular (SunDir, wN, wE, SpecIntensity*SpecRatio, SpecPow);
#endif

	float3 diff = ambc.xyz + (sun_diff + rim + sun_spec) * SunColor;

#ifdef sd_Light
	diff += calc_point_light (wP, wN, PointLight0Pos, PointLight0Clr);
	diff += calc_point_light (wP, wN, PointLight1Pos, PointLight1Clr);
	diff += calc_point_light (wP, wN, PointLight2Pos, PointLight2Clr);

	//wP.xyz += diff * 0.01;

	//diff += calc_distance_light (wP, PointLight0Pos, PointLight0Clr);
	//diff += calc_distance_light (wP, PointLight1Pos, PointLight1Clr);
	//diff += calc_distance_light (wP, PointLight2Pos, PointLight2Clr);
#endif

#ifdef sd_Color
	diff += (CLR0.xyz * 5.0);
#endif

#ifdef sd_SeaRefl
	wP.x += sin (wP.z * CTIME * 2.0) * 0.03;
	wP.y += sin (wP.z * CTIME * 2.0) * 0.03;
#endif

	vs_out_p = matVP * float4 (wP.xyz, 1.0);
	vs_out_0 = float4 (diff*UserColor.xyz, UserColor.w);
	vs_out_1 = float4 (TUV0.xy, wP.z, sun_spec);

#ifdef sd_Detail
	vs_out_2 = float4 (reflect(-wE.xzy, wN.xzy), ReflRatio);
#endif

#ifdef sd_Item
	vs_out_2 = float4 (reflect(-wE.xzy, wN.xzy), ReflRatio);
#endif

}

#endif



//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

	#define ColorKey		0.03
	#define DiffColor		ps_in_0.xyzw
	#define TexUV				ps_in_1.xy
	#define WPosZ				ps_in_1.z
	#define SunSpec			ps_in_1.w
	#define ReflUV			ps_in_2.xyz

void main () 
{ 
#ifdef sd_GlowX
	ps_out_c = texture2D (c_samp0, TexUV ) * DiffColor;
	//float4 texD = texture2D (c_samp0, TexUV );
	//float3 rcolor = texD.xyz * DiffColor.xyz + DiffColor.xyz * texD.w * SunSpec;
	//ps_out_c = float4 (rcolor.xyz, DiffColor.w);
#endif
	
#ifdef sd_GlowO
	float4 texD = texture2D (c_samp0, TexUV ).xyzw;	 
	texD.xyz *= DiffColor.xyz;
	texD.xyz += ( texD.xyz * GlowColor.xyz * texD.w );
	ps_out_c = float4 (texD.xyz, DiffColor.w);
#endif

#ifdef sd_SeaRefl
	if (WPosZ < 0.0) discard;
	ps_out_c = texture2D (c_samp0, TexUV ) * DiffColor;
#endif

#ifdef sd_Detail
	float4 texD = texture2D (c_samp0, TexUV ).xyzw;	 
	float4 texR = textureCB (c_cube,  ReflUV ).xyzw;	 
	float3 rcolor = lerp (texD.xyz, texR.xyz, ReflRatio);
	ps_out_c = float4 (rcolor.xyz*DiffColor.xyz, texD.w*DiffColor.w);
#endif

#ifdef sd_Item
	float4 texD = texture2D (c_samp0, TexUV ).xyzw;	 
	float4 texR = textureCB (c_cube,  ReflUV ).xyzw;	 
	float3 rcolor = lerp (texD.xyz, texR.xyz, texD.w*ps_in_2.w);
	//float3 rcolor = texD.xyz + texR.xyz * texD.w * ps_in_2.w;
	ps_out_c = float4 (rcolor.xyz*DiffColor.xyz, DiffColor.w);
#endif

}

#endif







