//@vs
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef V_SHADER

	#define _CTIME_SEC_		c_parm0.w

	void main () 
	{	
		float4 wP = POS0.xyzw;
		float dist = calc_distance (EyePos, wP.xyz);
		float fog = 1.0 - get_dis_alpha (dist, FogNear, FogFar);
		float3 diff = float3(Ambient, Ambient, Ambient) + (SunColor * CLR0.w) + (CLR0.xyz * 5.0);

#ifdef sd_Light
	diff += calc_distance_light (wP.xyz, PointLight0Pos, PointLight0Clr);
	diff += calc_distance_light (wP.xyz, PointLight1Pos, PointLight1Clr);
	diff += calc_distance_light (wP.xyz, PointLight2Pos, PointLight2Clr);
#endif

#ifdef sd_TerrRefl
	wP.x += sin (wP.z * CTIME) * 0.15;
	wP.y += sin (wP.z * CTIME) * 0.15;
	wP.z *= -1.0;
	diff.xyz *= 0.5;
#endif

		vs_out_p = matWVP * wP;//POS0;
		vs_out_0 = float4 (diff.xyz, 1.0-saturate(fog));

#ifdef sd_TerrPlane
		vs_out_1.xy = (wP.xy/64.0)*LayerUVR;
		vs_out_1.z = TUV0.x;
#endif

#ifdef sd_TerrPlaneSimple
		vs_out_1.xy = (wP.xy/64.0)*LayerUVR;
		vs_out_1.z = TUV0.x;
#endif

#ifdef sd_TerrCliff
		vs_out_1.xy = TUV0.xy*LayerUVR;
#endif

#ifdef sd_TerrGeneral
		vs_out_1.xy = TUV0.xy*LayerUVR;
#endif

		vs_out_1.w = wP.z;
	}

#endif

//@ps
///////////////////////////////////////////////////////////////////////////////////////////////////////
#ifdef P_SHADER

	#define DiffColor				ps_in_0
	#define TileUV					ps_in_1.xy
	#define Splat						ps_in_1.z
	#define WPosZ						ps_in_1.w

	void main () 
	{ 
#ifdef sd_TerrPlane
		float4 texD0 = texture2D (c_samp0, TileUV);
		float4 texD1 = texture2D (c_samp1, TileUV);
		float4 texD = lerp (texD0, texD1, Splat);
		ps_out_c = float4 (texD.xyz*DiffColor.xyz, DiffColor.w);
#endif

#ifdef sd_TerrPlaneSimple
	ps_out_c = texture2D (c_samp0, TileUV) * DiffColor;
#endif

#ifdef sd_TerrCliff
	ps_out_c = texture2D (c_samp0, TileUV) * DiffColor;
#endif

#ifdef sd_TerrGeneral
		ps_out_c = texture2D (c_samp0, TileUV) * DiffColor;
#endif

#ifdef sd_TerrRefl
	if (WPosZ >= 0.0) discard;
	ps_out_c = texture2D (c_samp0, TileUV) * DiffColor;
#endif

	}

#endif













